import numpy as np
from scipy import io
import os
import torch
from experiment.main import args
view_train = dict()
view_test = dict()
view_val = dict()
path = '/home1/xuyilun/data_text/ReutersEN/reutersEN'
seed = args.seed
f = io.mmread(os.path.join(path,'reutersEN_1_EN.mtx'))
f2 = io.mmread(os.path.join(path,'reutersEN_2_EN.mtx'))
F = np.concatenate((f.todense(),f2.todense()),axis=0)
N = F.shape[0]
print(F.shape)
np.random.seed(seed)
np.random.shuffle(F)
training_split = int(N * 0.6)
val_split = int(N * 0.8)
print(training_split)
print('Single View Shape:',F.shape)
view_train[1] = torch.from_numpy(F).float()[:training_split]
view_test[1] = torch.from_numpy(F).float()[training_split:val_split]
view_val[1] = torch.from_numpy(F).float()[val_split:]

f = io.mmread(os.path.join(path,'reutersEN_1_FR.mtx'))
f2 = io.mmread(os.path.join(path,'reutersEN_2_FR.mtx'))
F = np.concatenate((f.todense(),f2.todense()),axis=0)
np.random.seed(seed)
np.random.shuffle(F)
view_train[2] = torch.from_numpy(F).float()[:training_split]
view_test[2] = torch.from_numpy(F).float()[training_split:val_split]
view_val[2] = torch.from_numpy(F).float()[val_split:]

f = io.mmread(os.path.join(path,'reutersEN_1_IT.mtx'))
f2 = io.mmread(os.path.join(path,'reutersEN_2_IT.mtx'))
F = np.concatenate((f.todense(),f2.todense()),axis=0)
np.random.seed(seed)
np.random.shuffle(F)
view_train[3] = torch.from_numpy(F).float()[:training_split]
view_test[3] = torch.from_numpy(F).float()[training_split:val_split]
view_val[3] = torch.from_numpy(F).float()[val_split:]

f = io.mmread(os.path.join(path,'reutersEN_1_GR.mtx'))
f2 = io.mmread(os.path.join(path,'reutersEN_2_GR.mtx'))
F = np.concatenate((f.todense(),f2.todense()),axis=0)
np.random.seed(seed)
np.random.shuffle(F)
view_train[4] = torch.from_numpy(F).float()[:training_split]
view_test[4] = torch.from_numpy(F).float()[training_split:val_split]
view_val[4] = torch.from_numpy(F).float()[val_split:]

f = io.mmread(os.path.join(path,'reutersEN_1_SP.mtx'))
f2 = io.mmread(os.path.join(path,'reutersEN_2_SP.mtx'))
F = np.concatenate((f.todense(),f2.todense()),axis=0)
np.random.seed(seed)
np.random.shuffle(F)
view_train[5] = torch.from_numpy(F).float()[:training_split]
view_test[5] = torch.from_numpy(F).float()[training_split:val_split]
view_val[5] = torch.from_numpy(F).float()[val_split:]

f = open(os.path.join(path,'reutersEN_act.txt'))
lines = f.read()
collect = []
for r in lines:
    if r >= '1' and r<= '6':
        collect += [int(r)-1]

collect = np.array(collect)
collect = np.concatenate((collect,collect),axis=0)
np.random.seed(seed)
np.random.shuffle(collect)
label_train = collect[:training_split]
label_test = collect[training_split:val_split]
label_val = collect[val_split:]

split = int(len(label_train) * 0.1) #The fraction of the labeled data

#a = np.array([[1,1],[2,2],[3,3],[4,4],[5,5],[4,4],[3,3],[2,2],[1,1]])
#b = np.array([1,2,3,4,5,4,3,2,1])
#np.random.seed(1234)
#np.random.shuffle(a)
#np.random.seed(1234)
#np.random.shuffle(b)
#print(a,b)

