from __future__ import print_function
# -*- coding: utf-8 -*-
import torch

# torch.backends.cudnn.enabled=False
# torch.backends.cudnn.benchmark = True
#torch.backends.cudnn.deterministic = True
# torch.backends.cudnn.deterministic=True
import os
import random
import numpy as np
import copy
import torch.nn as nn
# torch.cuda.manual_seed_all(seed)

import sys

sys.path.append('../')
import torch.optim as optim
from torch.utils.data import DataLoader
from dataset.dataset_label_single import DatasetFromPerm_txt_boosting,DatasetFromPerm_txt_boosting_30T
from util.utils import *
from models.model import *
from experiment.get_item import get_opts, get_model, load_pytorch_model
import _pickle as pkl
from collections import OrderedDict
import torch
from experiment.learn_func_040 import train, test_model,train_mig,train_30T,train_hgr,train_hgr_combine


def worker_init_fn(
        worker_id):  # After creating the workers, each worker has an independent seed that is initialized to the curent random seed + the id of the worker
    a = 1

def test_combine():
    sys.setrecursionlimit(1000000)
    opt = get_opts()

    random.seed(opt.seed)
    np.random.seed(opt.seed)
    torch.manual_seed(opt.seed)
    torch.cuda.manual_seed(opt.seed)
    device = 0
    model_path = '/home1/xuyilun/model/adni/best_macro_F_beta_AD.pth.tar'

    for i in range(opt.n_fold):

        # train_dir = '%s/Dataset/pair_list/train_pair_%d_%d.txt' % (opt.base_dir, opt.dataset, i)
        # test_dir = '%s/Dataset/pair_list/test_pair_%d_%d.txt' % (opt.base_dir, opt.dataset, i)
        # validate_dir = '%s/Dataset/pair_list/validate_pair_%d_%d.txt' % (opt.base_dir, opt.dataset, i)
        supple = '_AD_NC'
        train_dir = '/home1/xuyilun/adni/dataset/Wechattrain' + supple + '_pair_625_0_semi_train_2.txt'
        train_dir_30T = '/home1/xuyilun/adni/dataset/Wechattrain' + supple + '_pair_625_0_30T.txt'
        # train_mig_dir = '/home1/xuyilun/adni/dataset/Wechattrain' + supple + '_pair_625_0_semi_mig.txt'
        train_mig_dir = '/home1/xuyilun/adni/dataset/Wechattrain' + supple + '_pair_625_0_semi_mig_2.txt'
        test_dir = '/home1/xuyilun/adni/dataset/Wechattest' + supple + '_pair_625_0_all_adas.txt'
        validate_dir = '/home1/xuyilun/adni/dataset/Wechatvalidate_2' + supple + '_pair_625_0.txt'

        test_set = DatasetFromPerm_txt_boosting(test_dir, crop_size=opt.crop_size, crop_mode='center', scale=1 / 255.0,
                                                is_seg=opt.isseg, is_class=opt.class_num, concat=opt.concat,
                                                W=opt.WC1, W2=opt.WC2, aug=0, flip=False, transpose=False,
                                                channel_num=opt.channel_num, merge_label=opt.merge, attr_id=opt.attr_id,
                                                pair_type=opt.pair_type, scaling=opt.scaling,path=True)


        testing_data_loader = DataLoader(dataset=test_set, num_workers=opt.threads, batch_size=opt.testBatchSize,
                                         shuffle=False, worker_init_fn=worker_init_fn)

        validate_set = DatasetFromPerm_txt_boosting(validate_dir, crop_size=opt.crop_size, crop_mode='center',
                                                    scale=1 / 255.0,
                                                    is_seg=opt.isseg, is_class=opt.class_num, concat=opt.concat,
                                                    W=opt.WC1, W2=opt.WC2, aug=0, flip=False, transpose=False,
                                                    channel_num=opt.channel_num, merge_label=opt.merge,
                                                    attr_id=opt.attr_id,
                                                    pair_type=opt.pair_type, scaling=opt.scaling)
        validate_data_loader = DataLoader(dataset=validate_set, num_workers=opt.threads, batch_size=opt.testBatchSize,
                                          shuffle=False, worker_init_fn=worker_init_fn)

        model_mri = get_model(opt).cuda()
        model_pet = get_model(opt).cuda()

        model_mri.load_state_dict(torch.load('./model_mig_mri_4567_0.3.pth.tar')['state_dict'])
        model_pet.load_state_dict(torch.load('./model_mig_pet_4567_0.3.pth.tar')['state_dict'])
        model_mri = nn.DataParallel(model_mri)
        model_pet = nn.DataParallel(model_pet)

        criterion = nn.CrossEntropyLoss()
        criterion = criterion.cuda()

        all_pred, all_labels, all_pred_L, test_losses ,path= test_model(model_mri, model_pet, 0, criterion,
                                                                   testing_data_loader, opt)

        all_pred = torch.FloatTensor(all_pred).squeeze(0)
        all_pred_L = torch.FloatTensor(all_pred_L).squeeze(0)
        all_pred_combine = F.softmax(all_pred, 1) * F.softmax(all_pred_L, 1) / torch.FloatTensor([0.6, 0.4])
        all_pred_combine2= F.softmax(all_pred, 1) * F.softmax(all_pred_L, 1)


        all_pred_combine = all_pred_combine.max(1)[1].long()
        all_pred_combine2 = all_pred_combine2.max(1)[1].long()
        all_pred = all_pred.max(1)[1].long()
        all_pred_L = all_pred_L.max(1)[1].long()
        all_labels = torch.FloatTensor(all_labels).squeeze(0).long()

        test_acc = all_pred.eq(all_labels.view_as(all_pred)).sum().item() * 1.0 / len(all_labels)
        test_acc_L = all_pred_L.eq(all_labels.view_as(all_pred_L)).sum().item() * 1.0 / len(all_labels)
        test_acc_combine = all_pred_combine.eq(all_labels.view_as(all_pred_combine)).sum().item() * 1.0 / len(all_labels)
        test_acc_combine2 = all_pred_combine2.eq(all_labels.view_as(all_pred_combine2)).sum().item() * 1.0 / len(all_labels)

        path = list(path)
        eq_mri = all_pred_L.eq(all_labels.view_as(all_pred))
        print("MRI:-----------------------------------")
        for i in range(len(eq_mri)):
            #print(path[i],eq_mri[i],all_labels[i])
            continue

        eq_mri_L = all_pred_L.eq(all_labels.view_as(all_pred_L))
        print("PET:-----------------------------------")
        for i in range(len(eq_mri)):
            print(path[i],eq_mri[i],all_labels[i])
            


        print(test_acc,test_acc_L,test_acc_combine,test_acc_combine2)



def main():
    sys.setrecursionlimit(1000000)
    opt = get_opts()

    random.seed(opt.seed)
    np.random.seed(opt.seed)
    torch.manual_seed(opt.seed)
    torch.cuda.manual_seed(opt.seed)
    device = 0
    model_path = '/home1/xuyilun/model/adni/best_macro_F_beta_AD.pth.tar'

    for i in range(opt.n_fold):
        p = torch.FloatTensor([0.6, 0.4])
        # train_dir = '%s/Dataset/pair_list/train_pair_%d_%d.txt' % (opt.base_dir, opt.dataset, i)
        # test_dir = '%s/Dataset/pair_list/test_pair_%d_%d.txt' % (opt.base_dir, opt.dataset, i)
        # validate_dir = '%s/Dataset/pair_list/validate_pair_%d_%d.txt' % (opt.base_dir, opt.dataset, i)
        supple = '_AD_NC'
        train_dir = '/home1/xuyilun/adni/dataset/Wechattrain'+supple+'_pair_625_0_semi_train_2.txt'
        train_dir_30T = '/home1/xuyilun/adni/dataset/Wechattrain' + supple + '_pair_625_0_30T.txt'
        train_mig_dir = '/home1/xuyilun/adni/dataset/Wechattrain' + supple + '_pair_625_0_semi_mig_2.txt'
        #train_mig_dir = '/home1/xuyilun/adni/dataset/Wechattrain' + supple + '_pair_625_0_semi_alltrain_adas.txt'
        test_dir = '/home1/xuyilun/adni/dataset/Wechattest_2'+supple+'_pair_625_0.txt'
        validate_dir = '/home1/xuyilun/adni/dataset/Wechatvalidate_2'+supple+'_pair_625_0.txt'

        train_set = DatasetFromPerm_txt_boosting(train_dir, crop_size=opt.crop_size, crop_mode='center',
                                                 scale=1 / 255.0,
                                                 is_seg=opt.isseg, is_class=opt.class_num, random_mask=opt.rand_mask,
                                                 random_mask_size=opt.rand_size, concat=opt.concat,
                                                 W=opt.WC1, W2=opt.WC2, aug=opt.aug, flip=opt.flip,
                                                 transpose=opt.transpose,
                                                 channel_num=opt.channel_num, shift=opt.shift, noise=opt.noise,
                                                 merge_label=opt.merge,
                                                 attr_id=opt.attr_id, pair_type=opt.pair_type, rotation=opt.rotation,
                                                 scaling=opt.scaling)
        train_set_30T = DatasetFromPerm_txt_boosting_30T(train_dir_30T, crop_size=opt.crop_size, crop_mode='center',
                                                 scale=1 / 255.0,
                                                 is_seg=opt.isseg, is_class=opt.class_num, random_mask=opt.rand_mask,
                                                 random_mask_size=opt.rand_size, concat=opt.concat,
                                                 W=opt.WC1, W2=opt.WC2, aug=opt.aug, flip=opt.flip,
                                                 transpose=opt.transpose,
                                                 channel_num=opt.channel_num, shift=opt.shift, noise=opt.noise,
                                                 merge_label=opt.merge,
                                                 attr_id=opt.attr_id, pair_type=opt.pair_type, rotation=opt.rotation,
                                                 scaling=opt.scaling)
        train_mig_set = DatasetFromPerm_txt_boosting(train_mig_dir, crop_size=opt.crop_size, crop_mode='center',
                                                 scale=1 / 255.0,
                                                 is_seg=opt.isseg, is_class=opt.class_num, random_mask=opt.rand_mask,
                                                 random_mask_size=opt.rand_size, concat=opt.concat,
                                                 W=opt.WC1, W2=opt.WC2, aug=opt.aug, flip=opt.flip,
                                                 transpose=opt.transpose,
                                                 channel_num=opt.channel_num, shift=opt.shift, noise=opt.noise,
                                                 merge_label=opt.merge,
                                                 attr_id=opt.attr_id, pair_type=opt.pair_type, rotation=opt.rotation,
                                                 scaling=opt.scaling)
        test_set = DatasetFromPerm_txt_boosting(test_dir, crop_size=opt.crop_size, crop_mode='center', scale=1 / 255.0,
                                                is_seg=opt.isseg, is_class=opt.class_num, concat=opt.concat,
                                                W=opt.WC1, W2=opt.WC2, aug=0, flip=False, transpose=False,
                                                channel_num=opt.channel_num, merge_label=opt.merge, attr_id=opt.attr_id,
                                                pair_type=opt.pair_type, scaling=opt.scaling)


        train_data_loader = DataLoader(dataset=train_set, num_workers=opt.threads, batch_size=opt.batchSize,shuffle=True, worker_init_fn=worker_init_fn)
        train_data_loader_30T = DataLoader(dataset=train_set_30T, num_workers=opt.threads, batch_size=opt.batchSize,
                                       shuffle=True, worker_init_fn=worker_init_fn)
        train_mig_data_loader = DataLoader(dataset=train_mig_set, num_workers=opt.threads, batch_size=12,shuffle=True, worker_init_fn=worker_init_fn)
        testing_data_loader = DataLoader(dataset=test_set, num_workers=opt.threads, batch_size=opt.testBatchSize,
                                         shuffle=False, worker_init_fn=worker_init_fn)

        validate_set = DatasetFromPerm_txt_boosting(validate_dir, crop_size=opt.crop_size, crop_mode='center',
        scale = 1 / 255.0,
        is_seg = opt.isseg, is_class = opt.class_num, concat = opt.concat,
        W = opt.WC1, W2 = opt.WC2, aug = 0, flip = False, transpose = False,
        channel_num = opt.channel_num, merge_label = opt.merge,
        attr_id = opt.attr_id,
        pair_type = opt.pair_type, scaling = opt.scaling)
        validate_data_loader = DataLoader(dataset=validate_set, num_workers=opt.threads, batch_size=opt.testBatchSize,
                                          shuffle=False, worker_init_fn=worker_init_fn)

        model_mri = get_model(opt).cuda()
        model_pet = get_model(opt).cuda()
        model_logistic = Classifier_hgr().cuda()

        model_mri = nn.DataParallel(model_mri)
        model_pet = nn.DataParallel(model_pet)
        model_logistic = nn.DataParallel(model_logistic)
        # model = load_pytorch_model(model, path=model_path, opt=opt)
        criterion = nn.CrossEntropyLoss()
        criterion = criterion.cuda()
        use_lr = opt.lr
        optimizer_mri = optim.Adam(model_mri.parameters(), lr=use_lr, weight_decay=opt.regularizer, amsgrad=True)
        optimizer_pet = optim.Adam(model_pet.parameters(), lr=use_lr, weight_decay=opt.regularizer, amsgrad=True)
        optimizer_logistic = optim.Adam(model_logistic.parameters(), lr=use_lr, weight_decay=opt.regularizer, amsgrad=True)

        opt.start_epoch = 1
        bestval_combine = -1
        bestval_mri = -1
        bestval_pet = -1
        besttest_combine = -1
        besttest_mri = -1
        besttest_pet = -1
        bestacc_mri = -1
        bestacc_pet = -1
        bestacc_combine = -1




        for epoch in range(opt.start_epoch, opt.nb_epochs + 1):

            '''
            all_pred, all_labels, train_losses = train_30T(model_mri,  epoch, optimizer_mri,  criterion, train_data_loader_30T, opt)
            all_pred = torch.FloatTensor(all_pred).squeeze(0)
            all_pred = all_pred.max(1)[1].long()
            all_labels = torch.FloatTensor(all_labels).squeeze(0).long()
            train_acc = all_pred.eq(all_labels.view_as(all_pred)).sum().item() * 1.0 / len(all_labels)
            print("Acc on 30T:{:.4f}".format(train_acc))
            '''

            if opt.hgr:
                all_pred, all_labels, all_pred_L, train_losses = train_hgr_combine(model_mri, model_pet, epoch, optimizer_mri,optimizer_pet, criterion, train_data_loader, opt,model_logistic=model_logistic,optimizer_logistic=optimizer_logistic)
            else:
                all_pred, all_labels, all_pred_L, train_losses = train(model_mri, model_pet, epoch, optimizer_mri, optimizer_pet, criterion, train_data_loader, opt)


            all_pred = torch.FloatTensor(all_pred).squeeze(0)
            all_pred_L = torch.FloatTensor(all_pred_L).squeeze(0)
            all_pred_combine = F.softmax(all_pred, 1) * F.softmax(all_pred_L, 1) / p

            all_pred_combine = all_pred_combine.max(1)[1].long()
            all_pred = all_pred.max(1)[1].long()
            all_pred_L = all_pred_L.max(1)[1].long()
            all_labels = torch.FloatTensor(all_labels).squeeze(0).long()

            train_acc = all_pred.eq(all_labels.view_as(all_pred)).sum().item() * 1.0 / len(all_labels)
            train_acc_L = all_pred_L.eq(all_labels.view_as(all_pred_L)).sum().item() * 1.0 / len(all_labels)
            train_acc_L_combine = all_pred_combine.eq(all_labels.view_as(all_pred_combine)).sum().item() * 1.0 / len(all_labels)
            if opt.hgr:
                all_pred, all_labels, all_pred_L, val_losses = test_model(model_mri,model_pet, epoch, criterion, validate_data_loader, opt, model_logistic=model_logistic)
            else:
                all_pred, all_labels, all_pred_L, val_losses = test_model(model_mri, model_pet, epoch, criterion, validate_data_loader, opt)

            all_pred = torch.FloatTensor(all_pred).squeeze(0)
            all_pred_L = torch.FloatTensor(all_pred_L).squeeze(0)

            all_pred_combine = F.softmax(all_pred, 1) * F.softmax(all_pred_L, 1) / p

            all_pred_combine = all_pred_combine.max(1)[1].long()
            all_pred = all_pred.max(1)[1].long()
            all_pred_L = all_pred_L.max(1)[1].long()
            all_labels = torch.FloatTensor(all_labels).squeeze(0).long()


            val_acc = all_pred.eq(all_labels.view_as(all_pred)).sum().item() * 1.0 / len(all_labels)
            val_acc_L = all_pred_L.eq(all_labels.view_as(all_pred_L)).sum().item() * 1.0 / len(all_labels)
            val_acc_combine = all_pred_combine.eq(all_labels.view_as(all_pred_combine)).sum().item() * 1.0 / len(all_labels)


            if opt.hgr:
                all_pred, all_labels, all_pred_L, test_losses = test_model(model_mri, model_pet, epoch, criterion, testing_data_loader, opt,model_logistic=model_logistic)
            else:
                all_pred, all_labels, all_pred_L, test_losses = test_model(model_mri, model_pet, epoch, criterion,testing_data_loader, opt)


            all_pred = torch.FloatTensor(all_pred).squeeze(0)
            all_pred_L = torch.FloatTensor(all_pred_L).squeeze(0)
            all_pred_combine = F.softmax(all_pred, 1) * F.softmax(all_pred_L, 1) / p

            all_pred_combine = all_pred_combine.max(1)[1].long()
            all_pred = all_pred.max(1)[1].long()
            all_pred_L = all_pred_L.max(1)[1].long()
            all_labels = torch.FloatTensor(all_labels).squeeze(0).long()


            test_acc = all_pred.eq(all_labels.view_as(all_pred)).sum().item() * 1.0 / len(all_labels)
            test_acc_L = all_pred_L.eq(all_labels.view_as(all_pred_L)).sum().item() * 1.0 / len(all_labels)
            test_acc_combine = all_pred_combine.eq(all_labels.view_as(all_pred_combine)).sum().item() * 1.0 / len(all_labels)
            if val_acc_combine > bestval_combine:
                bestval_combine = val_acc_combine
                besttest_combine = test_acc_combine
                print("====================++++++++++++++++++")
                print("Current Combine Test Acc:",test_acc_combine)
                print("====================++++++++++++++++++")
                if opt.hgr==1:
                    torch.save({'epoch': epoch, 'state_dict': model_mri.module.state_dict()}, 'model_hgr_mri_'+str(opt.file_seed)+'_'+str(opt.r)+'.pth.tar')
                    torch.save({'epoch': epoch, 'state_dict': model_pet.module.state_dict()}, 'model_hgr_pet_'+str(opt.file_seed)+'_'+str(opt.r)+'.pth.tar')


            if val_acc > bestval_mri:
                bestval_mri = val_acc
                besttest_mri = test_acc
                print("====================++++++++++++++++++")
                print("Current MRI Test Acc:",test_acc)
                print("====================++++++++++++++++++")
                if opt.mig==1:
                    torch.save({'epoch': epoch, 'state_dict': model_mri.module.state_dict()}, 'model_mig_mri_'+str(opt.file_seed)+'_'+str(opt.r)+'.pth.tar')
                elif opt.s==1:
                    torch.save({'epoch': epoch, 'state_dict': model_mri.module.state_dict()}, 'model_mri_'+str(opt.file_seed)+'_'+str(opt.r)+'.pth.tar')



            if val_acc_L > bestval_pet:
                bestval_pet = val_acc_L
                besttest_pet = test_acc_L

                print("====================++++++++++++++++++")
                print("Current PET Test Acc:",test_acc_L)
                print("====================++++++++++++++++++")
                if opt.mig==1:
                    torch.save({'epoch': epoch, 'state_dict': model_pet.module.state_dict()}, 'model_mig_pet_'+str(opt.file_seed)+'_'+str(opt.r)+'.pth.tar')
                elif opt.s==1:
                    torch.save({'epoch': epoch, 'state_dict': model_pet.module.state_dict()}, 'model_pet_'+str(opt.file_seed)+'_'+str(opt.r)+'.pth.tar')

            bestacc_mri = max(bestacc_mri,test_acc)
            bestacc_pet = max(bestacc_pet, test_acc_L)
            bestacc_combine = max(bestacc_combine, test_acc_combine)

            mig = False
            #if train_acc > 0.6 and train_acc_L > 0.6 and opt.mig == 1:
            if opt.mig == 1:
                mig = True
                all_pred, all_labels, all_pred_L, train_losses = train_mig(model_mri, model_pet, epoch, optimizer_mri, optimizer_pet, criterion, train_mig_data_loader, opt)

                all_pred = torch.FloatTensor(all_pred).squeeze(0)
                all_pred_L = torch.FloatTensor(all_pred_L).squeeze(0)
                all_pred_combine = F.softmax(all_pred, 1) * F.softmax(all_pred_L, 1)

                all_pred_combine = all_pred_combine.max(1)[1].long()
                all_pred = all_pred.max(1)[1].long()
                all_pred_L = all_pred_L.max(1)[1].long()
                all_labels = torch.FloatTensor(all_labels).squeeze(0).long()

                train_acc_mig = all_pred.eq(all_labels.view_as(all_pred)).sum().item() * 1.0 / len(all_labels)
                train_acc_L_mig = all_pred_L.eq(all_labels.view_as(all_pred_L)).sum().item() * 1.0 / len(all_labels)
                train_acc_L_combine_mig = all_pred_combine.eq(all_labels.view_as(all_pred_combine)).sum().item() * 1.0 / len(all_labels)

            if opt.mig:
                pass
                #print("Before MIG:")
            elif opt.hgr:
                pass
                #print("Before HGR:")

            print("MRI: Epoch:{}, Training acc:{:.4f}, Val acc:{:.4f}, Test acc:{:.4f}".format(epoch, train_acc, val_acc, test_acc))
            print("PET Epoch:{}, Training acc:{:.4f}, Val acc:{:.4f},Test acc:{:.4f}".format(epoch, train_acc_L, val_acc_L,test_acc_L))
            print("Combine Epoch:{}, Training acc:{:.4f}, Val acc:{:.4f},Test acc:{:.4f}".format(epoch, train_acc_L_combine,val_acc_combine, test_acc_combine))

            #if epoch % 50 == 0 and epoch != 0:

                #print('save model')
                #torch.save(model_mri.state_dict(), './model_mri_1e-3_bs_12_'+str(epoch)+'.pth.tar')
                #torch.save(model_pet.state_dict(), './model_pet_1e-3_bs_12_'+str(epoch)+'.pth.tar')
            if False:
                '''
                all_pred, all_labels, all_pred_L, val_losses = test_model(model_mri, model_pet, epoch, criterion,validate_data_loader, opt)

                all_pred = torch.FloatTensor(all_pred).squeeze(0)
                all_pred_L = torch.FloatTensor(all_pred_L).squeeze(0)
                all_pred_combine = F.softmax(all_pred, 1) * F.softmax(all_pred_L, 1)

                all_pred_combine = all_pred_combine.max(1)[1].long()
                all_pred = all_pred.max(1)[1].long()
                all_pred_L = all_pred_L.max(1)[1].long()
                all_labels = torch.FloatTensor(all_labels).squeeze(0).long()

                val_acc = all_pred.eq(all_labels.view_as(all_pred)).sum().item() * 1.0 / len(all_labels)
                val_acc_L = all_pred_L.eq(all_labels.view_as(all_pred_L)).sum().item() * 1.0 / len(all_labels)
                val_acc_combine = all_pred_combine.eq(all_labels.view_as(all_pred_combine)).sum().item() * 1.0 / len(
                    all_labels)
                '''
                all_pred, all_labels, all_pred_L, test_losses = test_model(model_mri, model_pet, epoch, criterion,testing_data_loader, opt)


                all_pred = torch.FloatTensor(all_pred).squeeze(0)
                all_pred_L = torch.FloatTensor(all_pred_L).squeeze(0)
                all_pred_combine = F.softmax(all_pred, 1) * F.softmax(all_pred_L, 1)

                all_pred_combine = all_pred_combine.max(1)[1].long()
                all_pred = all_pred.max(1)[1].long()
                all_pred_L = all_pred_L.max(1)[1].long()
                all_labels = torch.FloatTensor(all_labels).squeeze(0).long()

                test_acc = all_pred.eq(all_labels.view_as(all_pred)).sum().item() * 1.0 / len(all_labels)
                test_acc_L = all_pred_L.eq(all_labels.view_as(all_pred_L)).sum().item() * 1.0 / len(all_labels)
                test_acc_combine = all_pred_combine.eq(all_labels.view_as(all_pred_combine)).sum().item() * 1.0 / len(all_labels)
                print("After MIG:")
                print("MIG unlabel acc: D:{:.4f}, L:{:.4f}, C{:.4f}".format(train_acc_mig, train_acc_L_mig, train_acc_L_combine_mig))

                print("MRI: Epoch:{}, Test acc:{:.4f}".format(epoch, test_acc))
                print("PET Epoch:{},  Test acc:{:.4f}".format(epoch,test_acc_L))
                print("Combine Epoch:{},  Test acc:{:.4f}".format(epoch, test_acc_combine))


            if opt.hgr == 1:
                train_hgr(model_mri, model_pet, epoch, optimizer_mri, optimizer_pet, criterion, train_mig_data_loader, opt)

        print("====================++++++++++++++++++")
        print("Final Combine Test Acc:", besttest_combine)
        print("Final MRI Test Acc:", besttest_mri)
        print("Final PET Test Acc:", besttest_pet)
        print("====================++++++++++++++++++")
        print("Best Combine Test Acc:", bestacc_combine)
        print("Best MRI Test Acc:", bestacc_mri)
        print("Best PET Test Acc:", bestacc_pet)


if __name__ == '__main__':
    main()
    test_combine()
